% Synchronisation d'un metteur chaotique de Chua
% par l'algorithme de Marquardt.

% Paramtre du systmes de chua
clear
close all

delta_t=0.01;
N=25600;
Nbit=1; % Nombre de bits mis par utilisateurs
U=1; % U est le nombre d'utilisateur : on se limite  1


% Cration du signal chaotique de rfrence
Theta_i=randn(3,1);
sig_chua=chua(Theta_i,N*Nbit,delta_t)';
sig_emis=sig_chua(:,1);

% Cration du signal chaotique  reconstruire  partir de CI alatoire 
Theta_0=Theta_i+0.1*randn(3,1);


evolutionJ=[];


% Rcupration de chaque tat initial : Marquardt.

Epsilon=1e-3;
J=1e3;
Lambda=10^3;
indice=0;
Produit=eye(3);

while J>Epsilon
            
            
        
           Derive_Delta1x=zeros(3,1);
           Hessian_partiel=zeros(3,3);
           J_anc=J;
           sig_chua_rec=chua(Theta_0,N,delta_t)';
           sig_reconstruit=sig_chua_rec(:,1);

            drawnow
            plot(sig_chua_rec,'.')
            hold on
            plot(sig_chua)

           
           ecart=sig_emis-sig_reconstruit;
           J=mean(ecart.^2);
           
           for  k=1: N 

                   Df=Matrice_NL2(sig_reconstruit(k));
                   % Signal reconstruit est celui obtenu  partir de
                   % l'algorithme de Chua pour une condition initiale Thta connue.
                   % Signal_reconstruir(k,i) est le k-ime vecteur d'tat
                   % pour l'utilisateur estim i  partir des CI
                   % Thta_0(:,i).
            
                    Produit=Df*Produit;
                    % Je calcule l'approximation au premier ordre des
                    % erreurs obtenus d'un pas au pas suivant
                    % Il s'agit d'une matrice 3*3 en ce qui nous concernent
                    % Mais seul la premire ligne est utilise pour la
                    % calcul du gradient car on multiple Df par C
                    % puis par Theta et on drive enfin par les paramtres
                    % de thta
                    
                    
                    Derive_Delta1x=2*Produit(1,:)'*(ecart(k))+Derive_Delta1x;
                    Hessian_partiel=Hessian_partiel+2*Derive_Delta1x'*Derive_Delta1x;
                   % Derive_Delta1x reprsente pour un k donne le vecteur
                    % gradient estim pour les CI Theta
                    
               end
                
             Theta_0=Theta_0-inv(Lambda*eye(3)+Hessian_partiel)*Derive_Delta1x;

            
            % Algorithme de Marquardt est bas sur la diffrence de chemin entre le signal mis et rcupr 
           
            if J>J_anc
               Lambda=Lambda*10;
               
            elseif (J<=J_anc)
                   Lambda=Lambda/10;
            end
            J_anc=J;
                
            % Modification des paramtres Thta de chaque utilisateur
            % Elle est base sur le calcul du Gradient et de l'hessien
            % lesquels sont estims sur l'approximation au premier ordre
            % de la fonction NL.
            
           
           % Calcul du Jacobien pour chaque pas du signal modul et pour
           % chaque utilisateur
           
                    
             
           
            evolutionJ=[evolutionJ J];

             
              
%        Theta_0=Theta_0-inv(Lambda*diag(Hessian)+Hessian)*Gradient;
%Theta_0=Theta_0-inv(Lambda*eye(3))*Derive_Delta1x;
  end

fin=input('fin programme')